<?php

class Xanhte_UsersManager extends Xanhte_AppManager
{

	/**#@+
	 *	@access	private
	 */

	/**	@var	array	桼Υå */
	var $__cache_user ;  



	
	/***
	 * uid => unameѹ
	 * @access public
	 * @param int $uid 桼ID
	 * @return string $uname uname
	 */
	function uid2uname($uid){
		$uinfo =& $this->getUserinfoByUid($uid);
		return isset($uinfo['uname']) ? $uinfo['uname'] : '' ;
	}
	 
	 
	/***
	 * uname => uidѹ
	 * @access public
	 * @param string $uname 桼̾
	 * @return int $uid 
	 */
	function uname2uid($uname){
		$filter = array(
			'uname' => new Ethna_AppSearchObject($uname, OBJECT_CONDITION_EQ),
			'level' => new Ethna_AppSearchObject(0, OBJECT_CONDITION_GT)
			);
		$user = $this->getObjectProp('Users', null, $filter);

		if (!Ethna::isError($user) && $user){
			$this->__cache_user[$user['uid']] = $user ;
			return $user['uid'] ;
		}
		
		return -1 ;
	}
	 
	 
	/***
	 * uidǥ桼
	 * @access public
	 * @param int $uid 桼ID
	 * @return array 桼
	 */
	function getUserinfoByUid($uid){
		
		if (!isset($this->__cache_user[$uid])){
			$user = $this->getObjectProp('Users', null, array('uid' => new Ethna_AppSearchObject($uid, OBJECT_CONDITION_EQ)));
			$this->__cache_user[$uid] = $user ;
		}
		
		return $this->__cache_user[$uid] ;
	}

	/***
	 * ȴԥ롼פäƤ뤫ɤ
	 *
	 * @access public
	 * @return bool true=>yes  false=>no
	 */
	function isSiteAdmin(){
		global $xoopsUser;
		
		if (!is_object($xoopsUser)) return false ;
		$groups = $xoopsUser->getGroups();
		return in_array(1, $groups);
	}
	
	
	/***
	 * 桼ƿľ夲
	 *
	 * @access public
	 * @param int $point 夲ƿ
	 * @return array 桼
	 */
	function addUserPost($point=1){
		
		$uid = $this->getUid();
		
		$user = new Xanhte_Users(&$this->backend, 'uid', $uid);
		$user->set('posts', $user->get('posts')+$point);
		return $user->update();
	}
	
	
	
	/***
	 * ߤxoopsUser->getVar('uid')֤
	 * @access public
	 * @return array 桼
	 */
	function getUid(){
	
		global $xoopsUser;
		
		if (is_object($xoopsUser)){
			return $xoopsUser->getVar('uid');
		}
		return 0 ;
	}


	/***
	 * ߤxoopsUser->getVar('uname')֤
	 * @access public
	 * @return array 桼
	 */
	function getUname(){
	
		global $xoopsUser;
		
		if (is_object($xoopsUser)){
			return $xoopsUser->getVar('uname');
		}
		return '' ;
	}


}

class Xanhte_Users extends Xanhte_AppObject
{
    /**
     *  @var    array   ơ֥
     */
    var $table_def = 
        array(
			'users' => 
              array(
                    'primary' => true
                    ),
              );
    
    /**
     *  @var    array   ץѥƥ
     */
    var $prop_def = 
        array(
        'uid' => 
                array(
                      'primary'   => true, 
                      'key'       => true, 
					  'seq'       => true,
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'uid',
                      ),
        'name' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'name',
                      ),
        'uname' => 
                array(
                      'primary'   => false, 
                      'key'       => true, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'uname',
                      ),
        'email' => 
                array(
                      'primary'   => false, 
                      'key'       => true, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'email',
                      ),
        'url' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'url',
                      ),
        'user_avatar' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_avatar',
                      ),
        'user_regdate' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'user_regdate',
                      ),
        'user_icq' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_icq',
                      ),
        'user_from' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_from',
                      ),
        'user_sig' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_sig',
                      ),
        'user_viewemail' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'user_viewemail',
                      ),
        'actkey' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'actkey',
                      ),
        'user_aim' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_aim',
                      ),
        'user_yim' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_yim',
                      ),
        'user_msnm' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_msnm',
                      ),
        'pass' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'pass',
                      ),
        'posts' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'posts',
                      ),
        'attachsig' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'attachsig',
                      ),
        'rank' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'rank',
                      ),
        'level' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'level',
                      ),
        'theme' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'theme',
                      ),
        'timezone_offset' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'timezone_offset',
                      ),
        'last_login' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'last_login',
                      ),
        'umode' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'umode',
                      ),
        'uorder' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'uorder',
                      ),
        'notify_method' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'notify_method',
                      ),
        'notify_mode' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'notify_mode',
                      ),
        'user_occ' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_occ',
                      ),
        'bio' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'bio',
                      ),
        'user_intrest' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_STRING,
                      'form_name' => 'user_intrest',
                      ),
        'user_mailok' => 
                array(
                      'primary'   => false, 
                      'key'       => false, 
                      'type'      => VAR_TYPE_INT,
                      'form_name' => 'user_mailok',
                      ),

              );
    
    function getName($key)
    {
        return $this->get($key);
    }

	/**
	 *	Module饹Υ󥹥ȥ饯
	 *
	 *	@access	public
	 *	@param	object	Ethna_Backend	&$backend	Ethna_Backend֥
	 *	@param	mixed	$key_type					
	 *	@param	mixed	$key						
	 *	@param	array	$prop						ץѥƥ
	 */
	function Xanhte_Users(&$backend, $key_type = null, $key = null, $prop = null)
	{
		$this->Xanhte_AppObject(&$backend, $key_type, $key, $prop);
	    // ֥ȼԤϤ˵Ҥޤ
	}
}

?>