<?php
$mydirname = basename( dirname( __FILE__ ) ) ;
if( ! preg_match( '/^(\D+)(\d*)$/' , $mydirname , $regs ) ) echo ( "invalid dirname: " . htmlspecialchars( $mydirname ) ) ;
$mydirnumber = $regs[2] === '' ? '' : strval( $regs[2] ) ;

// <--- BASIC PROPERTY --->
$modversion['name'] = _MI_NEWBB_NAME;
$modversion['version'] = "1.66";
$modversion['description'] = _MI_NEWBB_DESC;
$modversion['credits'] = "ITT-WEB Ethna Applications";
$modversion['author'] = "ITOH Takashi" ;
$modversion['license'] = "BSD License";
$modversion['official'] = 0;
$modversion['image'] = "images/xoopsbb_slogo.png";
$modversion['dirname'] = $mydirname;
$modversion['use_smarty'] = 1;


// <--- SQL PROPERTY --->
$modversion['sqlfile']['mysql'] = "sql/mysql.sql";

// Tables created by sql file (without prefix!)
$modversion['tables'][0] = "bb".$mydirnumber."_categories";
$modversion['tables'][1] = "bb".$mydirnumber."_forum_access";
$modversion['tables'][2] = "bb".$mydirnumber."_forum_mods";
$modversion['tables'][3] = "bb".$mydirnumber."_forums";
$modversion['tables'][4] = "bb".$mydirnumber."_posts";
$modversion['tables'][5] = "bb".$mydirnumber."_posts_text";
$modversion['tables'][6] = "bb".$mydirnumber."_topics";

// <--- ADMIN PROPERTY --->
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "index.php?action_admin_index=1";
$modversion['adminmenu'] = "admin_menu.php";

// <--- MENU PROPERTY --->
$modversion['hasMain'] = 1;
/*
$modversion['sub'][1]['name'] = _MI_XEBLOG_SMNAME2;
$modversion['sub'][1]['url'] = '?action_newbb_post=1';
$modversion['sub'][2]['name'] = _MI_XEBLOG_SMNAME3;
$modversion['sub'][2]['url'] = '?action_newbb_archives=1';
*/

$modversion['config'] = array() ;
$modversion['config'][1] = array(
	'name' => 'template_type',
	'title' => '_MI_NEWBB_TEMPLATE_TYPE',
	'description' => '_MI_NEWBB_TEMPLATE_TYPEDSC',
	'formtype' => 'select',
	'valuetype' => 'text',
	'default' => 'DB',
	'options' => array('DB' => 'DB', 'FILE'=> 'FILE' )
) ;

// For XOOPS APIs (blocks, comments, search, notification)
if(!function_exists('xoopsAPI2Xanhte')){
	function xoopsAPI2Xanhte($action_name){
		ob_start();
		require_once XOOPS_ROOT_PATH."/modules/xanhte/main.php";
		xanhteSub::Ethna_bootup($action_name);
		$var = unserialize(ob_get_contents());
		ob_end_clean();
		return $var ;
	}
}


// Blocks
$modversion['blocks'][1] = array(
	'file' => "newbb_blocks.php",
	'name' => _MI_NEWBB_BNAME1,
	'description' => "Shows recent topics in the forums",
	'show_func' => "b_newbb_new_show",
	'options' => "10|1|time",
	'edit_func' => "b_newbb_new_edit",
	);
$modversion['blocks'][] = array(
	'file' => "newbb_blocks.php",
	'name' => _MI_NEWBB_BNAME2,
	'description' => "Shows most viewed topics in the forums",
	'show_func' => "b_newbb_top_show",
	'options' => "10|1|views",
	'edit_func' => "b_newbb_new_edit",
	);
$modversion['blocks'][] = array(
	'file' => "newbb_blocks.php",
	'name' => _MI_NEWBB_BNAME3,
	'description' => "Shows most active topics in the forums",
	'show_func' => "b_newbb_active_show",
	'options' => "10|1|replies",
	'edit_func' => "b_newbb_new_edit",
	);
$modversion['blocks'][] = array(
	'file' => "newbb_blocks.php",
	'name' => _MI_NEWBB_BNAME4,
	'description' => "Shows recent and private topics in the forums",
	'show_func' => "b_newbb_new_private_show",
	'options' => "10|1|time",
	'edit_func' => "b_newbb_new_edit",
	);


// Templates(main)
$modversion['templates'][1] = array(
	'file' => $mydirname.'_index.html',
	'description' => 'module');
$modversion['templates'][2] = array(
	'file' => $mydirname.'_search.html',
	'description' => 'module');
$modversion['templates'][3] = array(
	'file' => $mydirname.'_searchresults.html',
	'description' => 'module');
$modversion['templates'][4] = array(
	'file' => $mydirname.'_thread.html',
	'description' => 'module');
$modversion['templates'][5] = array(
	'file' => $mydirname.'_viewforum.html',
	'description' => 'module');
$modversion['templates'][6] = array(
	'file' => $mydirname.'_viewtopic_flat.html',
	'description' => 'module');
$modversion['templates'][7] = array(
	'file' => $mydirname.'_viewtopic_thread.html',
	'description' => 'module');
// Templates(block)
$modversion['templates'][8] = array(
	'file' => $mydirname.'_block_new.html',
	'description' => 'block',);
$modversion['templates'][9] = array(
	'file' => $mydirname.'_block_top.html',
	'description' => 'block',);
$modversion['templates'][10] = array(
	'file' => $mydirname.'_block_active.html',
	'description' => 'block',);
$modversion['templates'][11] = array(
	'file' => $mydirname.'_block_private.html',
	'description' => 'block',);

// XOOPS API Search
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = 'admin_menu.php'; // dummy
$modversion['search']['func'] = create_function('$keywords , $andor , $limit , $offset , $uid', '
    $_GET["query"] = $keywords;
    $_GET["andor"] = $andor;
    $_GET["limit"] = $limit;
    $_GET["offset"] = $offset; 
    $_GET["uid"] = $uid;
    $_GET["dirname"] = basename(dirname(__FILE__));
    return xoopsAPI2Xanhte("search_newbb");
');


// Notification
$modversion['hasNotification'] = 1;

$modversion['notification']['category'][1]['name'] = 'thread';
$modversion['notification']['category'][1]['title'] = _MI_NEWBB_THREAD_NOTIFY;
$modversion['notification']['category'][1]['description'] = _MI_NEWBB_THREAD_NOTIFYDSC;
$modversion['notification']['category'][1]['subscribe_from'] = 'index.php';
$modversion['notification']['category'][1]['item_name'] = 'topic_id';
$modversion['notification']['category'][1]['allow_bookmark'] = 1;

$modversion['notification']['category'][2]['name'] = 'forum';
$modversion['notification']['category'][2]['title'] = _MI_NEWBB_FORUM_NOTIFY;
$modversion['notification']['category'][2]['description'] = _MI_NEWBB_FORUM_NOTIFYDSC;
$modversion['notification']['category'][2]['subscribe_from'] = 'index.php';
$modversion['notification']['category'][2]['item_name'] = 'forum';
$modversion['notification']['category'][2]['allow_bookmark'] = 1;

$modversion['notification']['category'][3]['name'] = 'global';
$modversion['notification']['category'][3]['title'] = _MI_NEWBB_GLOBAL_NOTIFY;
$modversion['notification']['category'][3]['description'] = _MI_NEWBB_GLOBAL_NOTIFYDSC;
$modversion['notification']['category'][3]['subscribe_from'] = 'index.php';

$modversion['notification']['event'][1]['name'] = 'new_post';
$modversion['notification']['event'][1]['category'] = 'thread';
$modversion['notification']['event'][1]['title'] = _MI_NEWBB_THREAD_NEWPOST_NOTIFY;
$modversion['notification']['event'][1]['caption'] = _MI_NEWBB_THREAD_NEWPOST_NOTIFYCAP;
$modversion['notification']['event'][1]['description'] = _MI_NEWBB_THREAD_NEWPOST_NOTIFYDSC;
$modversion['notification']['event'][1]['mail_template'] = 'thread_newpost_notify';
$modversion['notification']['event'][1]['mail_subject'] = _MI_NEWBB_THREAD_NEWPOST_NOTIFYSBJ;

$modversion['notification']['event'][2]['name'] = 'new_thread';
$modversion['notification']['event'][2]['category'] = 'forum';
$modversion['notification']['event'][2]['title'] = _MI_NEWBB_FORUM_NEWTHREAD_NOTIFY;
$modversion['notification']['event'][2]['caption'] = _MI_NEWBB_FORUM_NEWTHREAD_NOTIFYCAP;
$modversion['notification']['event'][2]['description'] = _MI_NEWBB_FORUM_NEWTHREAD_NOTIFYDSC;
$modversion['notification']['event'][2]['mail_template'] = 'forum_newthread_notify';
$modversion['notification']['event'][2]['mail_subject'] = _MI_NEWBB_FORUM_NEWTHREAD_NOTIFYSBJ;

$modversion['notification']['event'][3]['name'] = 'new_forum';
$modversion['notification']['event'][3]['category'] = 'global';
$modversion['notification']['event'][3]['title'] = _MI_NEWBB_GLOBAL_NEWFORUM_NOTIFY;
$modversion['notification']['event'][3]['caption'] = _MI_NEWBB_GLOBAL_NEWFORUM_NOTIFYCAP;
$modversion['notification']['event'][3]['description'] = _MI_NEWBB_GLOBAL_NEWFORUM_NOTIFYDSC;
$modversion['notification']['event'][3]['mail_template'] = 'global_newforum_notify';
$modversion['notification']['event'][3]['mail_subject'] = _MI_NEWBB_GLOBAL_NEWFORUM_NOTIFYSBJ;

$modversion['notification']['event'][4]['name'] = 'new_post';
$modversion['notification']['event'][4]['category'] = 'global';
$modversion['notification']['event'][4]['title'] = _MI_NEWBB_GLOBAL_NEWPOST_NOTIFY;
$modversion['notification']['event'][4]['caption'] = _MI_NEWBB_GLOBAL_NEWPOST_NOTIFYCAP;
$modversion['notification']['event'][4]['description'] = _MI_NEWBB_GLOBAL_NEWPOST_NOTIFYDSC;
$modversion['notification']['event'][4]['mail_template'] = 'global_newpost_notify';
$modversion['notification']['event'][4]['mail_subject'] = _MI_NEWBB_GLOBAL_NEWPOST_NOTIFYSBJ;

$modversion['notification']['event'][5]['name'] = 'new_post';
$modversion['notification']['event'][5]['category'] = 'forum';
$modversion['notification']['event'][5]['title'] = _MI_NEWBB_FORUM_NEWPOST_NOTIFY;
$modversion['notification']['event'][5]['caption'] = _MI_NEWBB_FORUM_NEWPOST_NOTIFYCAP;
$modversion['notification']['event'][5]['description'] = _MI_NEWBB_FORUM_NEWPOST_NOTIFYDSC;
$modversion['notification']['event'][5]['mail_template'] = 'forum_newpost_notify';
$modversion['notification']['event'][5]['mail_subject'] = _MI_NEWBB_FORUM_NEWPOST_NOTIFYSBJ;

$modversion['notification']['event'][6]['name'] = 'new_fullpost';
$modversion['notification']['event'][6]['category'] = 'global';
$modversion['notification']['event'][6]['admin_only'] = 1;
$modversion['notification']['event'][6]['title'] = _MI_NEWBB_GLOBAL_NEWFULLPOST_NOTIFY;
$modversion['notification']['event'][6]['caption'] = _MI_NEWBB_GLOBAL_NEWFULLPOST_NOTIFYCAP;
$modversion['notification']['event'][6]['description'] = _MI_NEWBB_GLOBAL_NEWFULLPOST_NOTIFYDSC;
$modversion['notification']['event'][6]['mail_template'] = 'global_newfullpost_notify';
$modversion['notification']['event'][6]['mail_subject'] = _MI_NEWBB_GLOBAL_NEWFULLPOST_NOTIFYSBJ;

// under here added 2003-12-04 hhankt
$modversion['notification']['event'][7]['name'] ='new_fullpost';
$modversion['notification']['event'][7]['category'] ='forum';
$modversion['notification']['event'][7]['admin_only'] = 0;
$modversion['notification']['event'][7]['title'] =_MI_NEWBB_FORUM_NEWFULLPOST_NOTIFY;
$modversion['notification']['event'][7]['caption'] =_MI_NEWBB_FORUM_NEWFULLPOST_NOTIFYCAP;
$modversion['notification']['event'][7]['description'] =_MI_NEWBB_FORUM_NEWFULLPOST_NOTIFYDSC;
$modversion['notification']['event'][7]['mail_template'] ='forum_newfullpost_notify';
$modversion['notification']['event'][7]['mail_subject'] =_MI_NEWBB_FORUM_NEWFULLPOST_NOTIFYSBJ;
$modversion['notification']['event'][8]['name'] ='new_fullpost';
$modversion['notification']['event'][8]['category'] ='thread';
$modversion['notification']['event'][8]['admin_only'] = 0;
$modversion['notification']['event'][8]['title'] =_MI_NEWBB_THREAD_NEWFULLPOST_NOTIFY;
$modversion['notification']['event'][8]['caption'] =_MI_NEWBB_THREAD_NEWFULLPOST_NOTIFYCAP;
$modversion['notification']['event'][8]['description'] =_MI_NEWBB_THREAD_NEWFULLPOST_NOTIFYDSC;
$modversion['notification']['event'][8]['mail_template'] ='thread_newfullpost_notify';
$modversion['notification']['event'][8]['mail_subject'] =_MI_NEWBB_THREAD_NEWFULLPOST_NOTIFYSBJ;
?>
